/***********************************************************************
 *      This example program is an excerpt from the book:              *
 *                                                                     *
 *          X Window OSF/Motif Toolkit Programming (I)                 *
 *            - Programming Basics, Resource and Event -               *
 *                                                                     *
 *      Copyright 1994, Hideyuki Hayashi                               *
 *                                                                     *
 *      This program can be distributed without fee, provided          *
 *      that the above copyright notice appear in all copies.          *
 ***********************************************************************/

#include <Xm/XmAll.h>

static void ShowDialogCB();
static void RemoveDialogCB();

main(argc, argv)
    int  argc;
    char **argv;
{
    XtAppContext app_context;
    Widget  toplevel, rowcol, show, remove, dialog;
    Arg     al[20];
    int     ac;

    XtSetLanguageProc(NULL, NULL, NULL);

    ac = 0;
    toplevel = XtAppInitialize(&app_context, "Showdialog", NULL, 0,
                               &argc, argv, NULL, al, ac);

    ac = 0;
    rowcol = XmCreateRowColumn(toplevel, "rowcol", al, ac);
    XtManageChild(rowcol);

    ac = 0;
    show = XmCreatePushButton(rowcol, "show", al, ac);
    XtManageChild(show);

    ac = 0;
    remove = XmCreatePushButton(rowcol, "remove", al, ac);
    XtManageChild(remove);

    ac = 0;
    dialog = XmCreateMessageDialog(toplevel, "dialog", al, ac);
    /* Do not normally manage a dialog beforehand */

    /* The dialog will be shown when user presses the "show" button. */
    XtAddCallback(show, XmNactivateCallback, ShowDialogCB, dialog);
    /* The dialog will be removed when user presses the "removed" button. */
    XtAddCallback(remove, XmNactivateCallback, RemoveDialogCB, dialog);

    XtRealizeWidget(toplevel);
    XtAppMainLoop(app_context);
}

static void ShowDialogCB(w, client_data, call_data)
    Widget    w;
    XtPointer client_data;
    XtPointer call_data;
{
    Widget dialog = (Widget)client_data;

    if (!XtIsManaged(dialog))  /* Check if the dialog is not managed */
        XtManageChild(dialog); /* and manage the dialog */
}

static void RemoveDialogCB(w, client_data, call_data)
    Widget    w;
    XtPointer client_data;
    XtPointer call_data;
{
    Widget dialog = (Widget)client_data;

    if (XtIsManaged(dialog))     /* Check if the dialog is managed */
        XtUnmanageChild(dialog); /* and unmanage the dialog */
}
