/***********************************************************************
 *      This example program is an excerpt from the book:              *
 *                                                                     *
 *          X Window OSF/Motif Toolkit Programming (I)                 *
 *            - Programming Basics, Resource and Event -               *
 *                                                                     *
 *      Copyright 1994, Hideyuki Hayashi                               *
 *                                                                     *
 *      This program can be distributed without fee, provided          *
 *      that the above copyright notice appear in all copies.          *
 ***********************************************************************/

#include <Xm/XmAll.h>

static void ToggleCB();

main(argc, argv)
    int  argc;
    char **argv;
{
    XtAppContext app_context;
    Widget  toplevel, rowcol, toggle;
    Arg     al[20];
    int     ac;

    XtSetLanguageProc(NULL, NULL, NULL);

    ac = 0;
    toplevel = XtAppInitialize(&app_context, "Togglecbinfo", NULL, 0,
                               &argc, argv, NULL, al, ac);

    ac = 0;
    rowcol = XmCreateRowColumn(toplevel, "rowcol", al, ac);
    XtManageChild(rowcol);

    ac = 0;
    toggle = XmCreateToggleButton(rowcol, "toggle", al, ac);
    XtManageChild(toggle);

    /* Register callback function to toggle button */
    XtAddCallback(toggle, XmNvalueChangedCallback, ToggleCB, NULL);

    XtRealizeWidget(toplevel);
    XtAppMainLoop(app_context);
}

static void ToggleCB(w, client_data, call_data)
    Widget    w;
    XtPointer client_data;
    XtPointer call_data;
{
    XmToggleButtonCallbackStruct *cb = (XmToggleButtonCallbackStruct *)call_data;
         /* VVV The current toggle state is stored in callback struct */
    if (cb->set) printf("Toggle is now ON.\n");
    else         printf("Toggle is now OFF.\n");
}
