/***********************************************************************
 *      This example program is an excerpt from the book:              *
 *                                                                     *
 *          X Window OSF/Motif Toolkit Programming (I)                 *
 *            - Programming Basics, Resource and Event -               *
 *                                                                     *
 *      Copyright 1994, Hideyuki Hayashi                               *
 *                                                                     *
 *      This program can be distributed without fee, provided          *
 *      that the above copyright notice appear in all copies.          *
 ***********************************************************************/

#include <Xm/XmAll.h>

main(argc, argv)
    int  argc;
    char **argv;
{
    XtAppContext app_context;
    Widget  toplevel, text;
    Arg     al[20];
    int     ac;

    XtSetLanguageProc(NULL, NULL, NULL);
    ac = 0;
    toplevel = XtAppInitialize(&app_context, "Multiclick", NULL, 0,
                               &argc, argv, NULL, al, ac);
    if (argc == 2) { /* (1) If non Xt option remains only one,
                            set the value to multi click time */
        int timeout;
              /* (2) check the original value */
        timeout = XtGetMultiClickTime(XtDisplay(toplevel));
        printf("Original multi click time was %d mili second.\n", timeout);
              /* (3) set the new value */
        XtSetMultiClickTime(XtDisplay(toplevel), atoi(argv[1]));
              /* (4) check the new value */
        timeout = XtGetMultiClickTime(XtDisplay(toplevel));
        printf("New multi click time is %d mili second.\n", timeout);
    }
    else if (argc > 2) {
              /* (5) If non Xt option remains more than two,
                     print the usage and exit */
        fprintf(stderr, "Usage: %s [toolkit options] timeout(mili sec).\n");
        exit(1);
    }
    /* (6) If non Xt option does not remain,
           do not change the multi click time */
    ac = 0;
    text = XmCreateText(toplevel, "text", al, ac);
    XtManageChild(text);

    XtRealizeWidget(toplevel);
    XtAppMainLoop(app_context);
}
